Package org.apache.groovy.ast.tools

## Class ImmutablePropertyUtils

- java.lang.Object
- - org.apache.groovy.ast.tools.ImmutablePropertyUtils

-     public class ImmutablePropertyUtils
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ClassNode` | `IMMUTABLE_OPTIONS_TYPE` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static boolean` | `builtinOrMarkedImmutableClass​(java.lang.Class<?> clazz)` |
    `static Expression` | `cloneArrayOrCloneableExpr​(Expression fieldExpr, ClassNode type)` |
    `static Expression` | `cloneDateExpr​(Expression origDate)` |
    `static java.lang.String` | `createErrorMessage​(java.lang.String className, java.lang.String fieldName, java.lang.String typeName, java.lang.String mode)` |
    `static boolean` | `derivesFromDate​(ClassNode fieldType)` |
    `static java.util.List<java.lang.String>` | `getKnownImmutableClasses​(AbstractASTTransformation xform, ClassNode cNode)` |
    `static java.util.List<java.lang.String>` | `getKnownImmutables​(AbstractASTTransformation xform, ClassNode cNode)` |
    `static boolean` | `implementsCloneable​(ClassNode fieldType)` |
    `static boolean` | `isBuiltinImmutable​(java.lang.String typeName)` |
    `static boolean` | `isKnownImmutableType​(ClassNode fieldType, java.util.List<java.lang.String> knownImmutableClasses)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### IMMUTABLE_OPTIONS_TYPE

          public static final ClassNode IMMUTABLE_OPTIONS_TYPE

  - ### Method Detail

    - #### cloneArrayOrCloneableExpr

          public static Expression cloneArrayOrCloneableExpr​(Expression fieldExpr,
                                                             ClassNode type)

    - #### implementsCloneable

          public static boolean implementsCloneable​(ClassNode fieldType)

    - #### cloneDateExpr

          public static Expression cloneDateExpr​(Expression origDate)

    - #### derivesFromDate

          public static boolean derivesFromDate​(ClassNode fieldType)

    - #### createErrorMessage

          public static java.lang.String createErrorMessage​(java.lang.String className,
                                                            java.lang.String fieldName,
                                                            java.lang.String typeName,
                                                            java.lang.String mode)

    - #### isKnownImmutableType

          public static boolean isKnownImmutableType​(ClassNode fieldType,
                                                     java.util.List<java.lang.String> knownImmutableClasses)

    - #### isBuiltinImmutable

          public static boolean isBuiltinImmutable​(java.lang.String typeName)

    - #### builtinOrMarkedImmutableClass

          public static boolean builtinOrMarkedImmutableClass​(java.lang.Class<?> clazz)

    - #### getKnownImmutables

          public static java.util.List<java.lang.String> getKnownImmutables​(AbstractASTTransformation xform,
                                                                            ClassNode cNode)

    - #### getKnownImmutableClasses

          public static java.util.List<java.lang.String> getKnownImmutableClasses​(AbstractASTTransformation xform,
                                                                                  ClassNode cNode)